//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Spreadsheet.h"
#include "uCalcCPP.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

void _stdcall CellArrayValue(DWORD Expr);
void SetCellValue(long cRow, long cCol, char* CellContent);
void UpdateDepCells(long GridCell, long double CellValue);
void SetColName(char* ColumnName, long ArrayCol);
void SpreadSheetInit();
void ProcessCellNames(char* Eq);

const long MaxRow = 10;
const long MaxCol = 5;
const long ArraySpace = 50; // MaxRow * MaxCol
char ColumnName[MaxCol][80];
char CellEq[ArraySpace][80];
char CellName[MaxRow][MaxCol][80];
AnsiString NewCellName;

bool UpdatingDepCells;
long CurrentCell, DepIndex, CellRow, CellCol;

long double CellArray[ArraySpace];
long DepNext[ArraySpace];
long FormulaPtr[ArraySpace];
long DepList[ArraySpace];
long DepStart[ArraySpace];
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
DWORD _stdcall MyErrorHandler(DWORD t)
{
   if(ucError(t) == uc_Err_Undefined_Identifier)
   NewCellName = ucErrSymbol(t);

   return ucAbort;
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   char Alpha[] = " ABCDE";
   long x;

   ucDefineFunction("Native: Cell(Row, Col)", CellArrayValue);
   uCalc(uc_AddErrorHandler, 0, (DWORD)MyErrorHandler);

   for(x = 1; x <= MaxCol; x++)
   {
      Grid1->Cells[x][0] = Alpha[x];
      ColumnName[x][0] = Alpha[x];
      SetColName(ColumnName[x], x);
   }

   for(x=  1; x <= MaxRow; x++)
      Grid1->Cells[0][x] = IntToStr(x);

   Grid1->Row = 1;
   Grid1->Col = 1;
   Show();
   Grid1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSetColumnNameClick(TObject *Sender)
{
   strcpy(ColumnName[CellCol], txtColumn->Text.c_str());
   SetColName(ColumnName[CellCol], CellCol);
}
//---------------------------------------------------------------------------

void _stdcall CellArrayValue(DWORD Expr)
{
   long CellAddress, iIndex, TmpIndex;
   long cRow, cCol;

   cRow = ucParam(Expr, 1);
   cCol = ucParam(Expr, 2);

   CellAddress = (cCol - 1) * MaxRow + cRow;
   ucReturn(Expr, CellArray[CellAddress]);

   if(UpdatingDepCells == True) return;   

   if(DepStart[CellAddress] == 0)
   {
      if(DepIndex == 0) DepIndex = DepIndex + 1;
      DepStart[CellAddress] = DepIndex;
      DepNext[DepIndex] = -1;
   }
   else
   {
      iIndex = DepStart[CellAddress];

      do
      {
         if(DepList[iIndex] == CurrentCell) return;

         if(DepNext[iIndex] == -1)
         {
            DepNext[iIndex] = DepIndex;
            DepNext[DepIndex] = -1;
            break;
         }

         TmpIndex = iIndex;
         iIndex = DepNext[iIndex];
      }

      while(DepNext[TmpIndex] != -1);
   }

   DepList[DepIndex] = CurrentCell;
   DepIndex = DepIndex + 1;   
}

void SetCellValue(long cRow, long cCol, char* CellContent)
{
   long EqPtr;
   long double CellValue;
    
   CurrentCell = (cCol - 1) * MaxRow + cRow;

   if(CellContent[0] == NULL) return;

   if(CellContent[0] == '=')
   {
      CellContent[0] = ' ';
      ProcessCellNames(CellContent);
      EqPtr = ucParse(CellContent);
      CellValue = ucEvaluate(EqPtr);
      FormulaPtr[CurrentCell] = EqPtr;
      CellContent[0] = '=';
      strcpy(CellEq[CurrentCell], CellContent);
   }
   else
   {
      CellValue = StrToFloat(CellContent);
   }

   UpdatingDepCells = True;
   UpdateDepCells(CurrentCell, CellValue);
   UpdatingDepCells = false;
}

void UpdateDepCells(long GridCell, long double CellValue)
{
   long iIndex, DepCell, TmpCol, TmpRow;
    
   TmpCol = (GridCell - 1) / MaxRow + 1;
   TmpRow = GridCell - (TmpCol - 1) * MaxRow;
   Form1->Grid1->Cells[TmpCol][TmpRow] = FloatToStr(CellValue);
   CellArray[GridCell] = CellValue;
    
   iIndex = DepStart[GridCell];
   if(iIndex != 0)
   {
      while(iIndex != -1)
      {
         DepCell = DepList[iIndex];
         CellValue = ucEvaluate(FormulaPtr[DepCell]);
         UpdateDepCells(DepCell, CellValue);
         iIndex = DepNext[iIndex];
      }
   }
}

void SetColName(char* ColumnName, long ArrayCol)
{
   char cName[80];
   strcpy(cName, ColumnName);
   strcat(cName, "(x)=Cell(x,");
   strcat(cName, IntToStr(ArrayCol).c_str());
   strcat(cName, ")");
   ucDefineFunction(cName);
}

void ProcessCellNames(char* Eq)
{
   ucEval(Eq);
   while(NewCellName.Length() != 0)
   {
      ucDefineSyntax(NewCellName + "::=" + NewCellName[1] + "(" + NewCellName.SubString(2, NewCellName.Length()-1) + ")");
      NewCellName = "";
      ucEval(Eq);
   }
}

void __fastcall TForm1::Grid1Click(TObject *Sender)
{
   long CellAddress;
   char TmpString[80];

   CellRow = Grid1->Row;
   CellCol = Grid1->Col;

   CellAddress = (CellCol - 1) * MaxRow + CellRow;

   if(CellEq[CellAddress][0] == '=')
   txtFormula->Text = CellEq[CellAddress];
   else txtFormula->Text = Grid1->Cells[CellCol][CellRow];

   txtColumn->Text = ColumnName[CellCol];
   txtCellName->Text = CellName[CellRow][CellCol];
   if(StrLen(txtCellName->Text.c_str()) == 0)
   {
      strcpy(TmpString, txtColumn->Text.c_str());
      strcat(TmpString, IntToStr(CellRow).c_str());
      txtCellName->Text = TmpString;
   }
   txtFormula->SetFocus();

   if(txtFormula->Text == "") txtFormula->Text = "=";
   txtFormula->SelStart = txtFormula->Text.Length();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::txtFormulaChange(TObject *Sender)
{
   Grid1->Cells[CellCol][CellRow] = txtFormula->Text;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::txtFormulaExit(TObject *Sender)
{
   if(txtFormula->Text == "=") txtFormula->Text = "";
   else SetCellValue(CellRow, CellCol, txtFormula->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::txtCellNameKeyPress(TObject *Sender, char &Key)
{
   if(Key == 13) // 13 = Enter
   {
      ucDefineSyntax(txtCellName->Text + "::=" + ColumnName[CellCol] + "(" + IntToStr(CellRow) + ")");
      strcpy(CellName[CellRow][CellCol], txtCellName->Text.c_str());
      Grid1->SetFocus();
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::txtFormulaKeyPress(TObject *Sender, char &Key)
{
   if (Key==13) SetCellValue(CellRow, CellCol, txtFormula->Text.c_str());
}
//---------------------------------------------------------------------------
