Option Strict Off
Option Explicit On
Module Module1
	Public Const MaxRow As Short = 10
	Public Const MaxCol As Short = 5
	Public ColumnName(MaxCol) As String
	Public CellEq() As String
    Public CellName(MaxRow, MaxCol) As String
    Public Delegate Function ucCallback_ErrHandler(ByVal t As Integer) As Integer

    Public Declare Function uCalc_eh Lib "ucFMP296.dll" Alias "uCalc" (ByVal ucCommand As Integer, _
               ByVal TextArg As String, ByVal ItemAddress As ucCallback_ErrHandler, ByVal MiscArg2 As Integer, _
               ByVal ReturnPtr As Integer, ByVal t As Integer) As Integer
	
	Dim Spreadsheet As AxMSGrid.AxGrid
	Dim UpdatingDepCells As Boolean
	Dim CurrentCell, DepIndex As Integer
	Dim DepNext() As Integer
	Dim CellArray() As Double
	Dim FormulaPtr() As Integer
	Dim DepList() As Integer
	Dim DepStart() As Integer
	Dim NewCellName As String
	
    Sub CellArrayValue(ByVal Expr As Integer)
        Dim iIndex, CellAddress, TmpIndex, CellRow, CellCol As Integer
        ReDim Preserve DepList(DepIndex + 2)
        ReDim Preserve DepNext(DepIndex + 2)

        CellRow = ucParamDbl(Expr, 1)
        CellCol = ucParamDbl(Expr, 2)

        CellAddress = (CellCol - 1) * MaxRow + CellRow
        ucReturnDbl(Expr, CellArray(CellAddress))

        If UpdatingDepCells = True Then Exit Sub

        If DepStart(CellAddress) = 0 Then
            If DepIndex = 0 Then DepIndex = DepIndex + 1
            DepStart(CellAddress) = DepIndex
            DepNext(DepIndex) = -1
        Else
            iIndex = DepStart(CellAddress)
            Do
                If DepList(iIndex) = CurrentCell Then Exit Sub
                If DepNext(iIndex) = -1 Then
                    DepNext(iIndex) = DepIndex
                    DepNext(DepIndex) = -1
                    Exit Do
                End If
                TmpIndex = iIndex
                iIndex = DepNext(iIndex)
            Loop While DepNext(TmpIndex) <> -1
        End If

        DepList(DepIndex) = CurrentCell
        DepIndex = DepIndex + 1
    End Sub

    Sub SetCellValue(ByRef CellRow As Integer, ByRef CellCol As Integer, ByRef CellContent As String)
        Dim EqPtr As Integer
        Dim CellValue As Double

        CurrentCell = (CellCol - 1) * MaxRow + CellRow

        If Left(CellContent, 1) = "=" Then
            Call ProcessCellNames(Mid(CellContent, 2))
            EqPtr = ucParse(Mid(CellContent, 2))
            CellValue = ucEvaluate(EqPtr)
            FormulaPtr(CurrentCell) = EqPtr
            CellEq(CurrentCell) = CellContent
        Else
            CellValue = Val(CellContent)
        End If

        UpdatingDepCells = True
        Call UpdateDepCells(CurrentCell, CellValue)
        UpdatingDepCells = False
    End Sub

    Sub UpdateDepCells(ByRef GridCell As Integer, ByRef CellValue As Double)
        Dim iIndex, DepCell As Integer

        Spreadsheet.Col = (GridCell - 1) \ MaxRow + 1
        Spreadsheet.Row = GridCell - (Spreadsheet.Col - 1) * MaxRow
        Spreadsheet.CtlText = CStr(CellValue)
        CellArray(GridCell) = CellValue

        iIndex = DepStart(GridCell)
        If iIndex <> 0 Then
            While iIndex <> -1
                DepCell = DepList(iIndex)
                CellValue = ucEvaluate(FormulaPtr(DepCell))
                Call UpdateDepCells(DepCell, CellValue)
                iIndex = DepNext(iIndex)
            End While
        End If
    End Sub

    Sub SetColName(ByRef ColumnName As String, ByRef ArrayCol As Integer)
        ucDefineFunction(ColumnName & "(x)=Cell(x," & Str(ArrayCol) & " )")
    End Sub

    Sub SpreadSheetInit(ByRef Grid1 As AxMSGrid.AxGrid)
        Static d_CellArrayValue As ucCallback = New ucCallback(AddressOf CellArrayValue)
        Static d_MyErrorHandler As ucCallback_ErrHandler = New ucCallback_ErrHandler(AddressOf MyErrorHandler)

        Dim ArraySpace As Integer
        Dim x As Integer
        Dim Alpha As String

        Spreadsheet = Grid1

        ArraySpace = MaxRow * MaxCol
        ReDim CellArray(ArraySpace)
        ReDim FormulaPtr(ArraySpace)
        ReDim CellEq(ArraySpace)
        ReDim DepStart(ArraySpace)

        ucDefineFunction("Native: Cell(CellRow, CellCol)", d_CellArrayValue)
        uCalc_eh(uc_AddErrorHandler, "", d_MyErrorHandler, 0, 0, 0)

        Alpha = "ABCDEFGHIJK"
        Grid1.Col = 0
        For x = 1 To MaxRow
            Grid1.Row = x
            Grid1.CtlText = CStr(x)
        Next

        Grid1.Row = 0
        For x = 1 To MaxCol
            Grid1.set_ColWidth(x, Grid1.get_ColWidth(x) * 2)
            Grid1.Col = x
            Grid1.CtlText = Mid(Alpha, x, 1)
            ColumnName(x) = Mid(Alpha, x, 1)
            SetColName(ColumnName(x), x)
        Next
    End Sub

    Function MyErrorHandler(ByVal t As Integer) As Integer
        If ucError(t) = uc_Err_Undefined_Identifier Then NewCellName = ucErrSymbol(t)
    End Function

    Sub ProcessCellNames(ByRef Eq As String)
        ucEval(Eq)
        While Len(NewCellName)
            ucDefineSyntax(NewCellName & "::=" & Left(NewCellName, 1) & "(" & Mid(NewCellName, 2) & ")")
            NewCellName = ""
            ucEval(Eq)
        End While
    End Sub
End Module