Attribute VB_Name = "uCalcVB"
' ------------------------------------------------------------------------
' uCalcVB.bas : Visual Basic include file for uCalc Fast Math Parser 2.96
' Designed to work with Visual Basic 5.0 and above.
'
' Copyright (c) 1999-2008 by Daniel Corbier.
' Visit www.ucalc.com for additional resources.
' ------------------------------------------------------------------------
Option Explicit
' Definition properties
Public Const ucAlphaNumeric As Long = 1
Public Const ucArgSeparator As Long = 2
Public Const ucCodeBlock As Long = 3
Public Const ucCodeBlockMatch As Long = 4
Public Const ucEvalInsert As Long = 5
Public Const ucExpandInsert As Long = 6
Public Const ucMemberAccess As Long = 7
Public Const ucQuotedText As Long = 8
Public Const ucStatementSep As Long = 9
Public Const ucWhiteSpace As Long = 10

Public Const ucFuncDefEnd As Long = 11
Public Const ucCurrentThread As Long = 12

Public Const ucPartialBlockStart As Long = 13
Public Const ucPartialBlockEnd As Long = 14

Public Const ucEvalDuringParse As Long = 15

Public Const ucFunction As Long = 16
Public Const ucLiteral As Long = 32
Public Const ucReducible As Long = 64
Public Const ucSymbol As Long = 128
Public Const ucVariable As Long = 256
Public Const ucInfix As Long = 512
Public Const ucPrefix As Long = 1024
Public Const ucPostfix As Long = 2048
Public Const ucOperator As Long = 4096
Public Const ucPassOnce As Long = 8192
Public Const ucLock As Long = 16384

' uCalc Commands
Public Const uc_Define As Long = 1
Public Const uc_DefineSyntax As Long = 2
Public Const uc_EvalDbl As Long = 4
Public Const uc_EvalExt As Long = 5
Public Const uc_EvalStr As Long = 6
Public Const uc_EvaluateDbl As Long = 7
Public Const uc_EvaluateExt As Long = 8
Public Const uc_Evaluate As Long = 8
Public Const uc_EvaluateLng As Long = 9
Public Const uc_EvaluateStr As Long = 10
Public Const uc_GetCaseSensitivity As Long = 11
Public Const uc_GetCodeAddr As Long = 12
Public Const uc_GetDefaultPrecedence As Long = 13
Public Const uc_GetDefaultRank As Long = 14
Public Const uc_GetDefaultType As Long = 15
Public Const uc_GetDefaultThread As Long = 16
Public Const uc_GetDefSeparator As Long = 17
Public Const uc_GetErrorNumber As Long = 18
Public Const uc_GetParentThread As Long = 19
Public Const uc_GetSyntaxEqual As Long = 20
Public Const uc_Parse As Long = 21
Public Const uc_ReleaseItem As Long = 22
Public Const uc_SetCaseSensitivity As Long = 23
Public Const uc_SetCodeAddr As Long = 24
Public Const uc_SetDefaultPrecedence As Long = 25
Public Const uc_SetDefaultRank As Long = 26
Public Const uc_SetDefaultThread As Long = 27
Public Const uc_SetDefaultType As Long = 28
Public Const uc_SetDefSeparator As Long = 29
Public Const uc_SetErrorNumber As Long = 30
Public Const uc_SetParentThread As Long = 31
Public Const uc_SetSyntaxEqual As Long = 32
Public Const uc_NewThread As Long = 33
Public Const uc_PartialBlockCount As Long = 34

Public Const uc_RegExWordBoundaryChars As Long = 35
Public Const uc_RegExEscapeChar As Long = 36
Public Const uc_License As Long = 37
Public Const uc_License_Demo As Long = 0  
Public Const uc_License_Free As Long = 2
Public Const uc_License_FMP_Lite As Long = 3
Public Const uc_License_FMP_Standard As Long = 4
Public Const uc_License_LanguageBuilder As Long = 5
Public Const uc_License_Beta As Long = 6


Public Const uc_AddErrorHandler As Long = 40

Public Const uc_GetSymbolTable As Long = 41

Public Const uc_GetCallbackData As Long = 50
Public Const uc_SetCallbackReturn As Long = 51

Public Const uc_GetExpression As Long = 60
Public Const uc_GetExpressionType As Long = 61
Public Const uc_GetSymbol As Long = 62
Public Const uc_GetItem As Long = 63
Public Const uc_GetLocation As Long = 64

Public Const uc_GetPatternType As Long = 65
Public Const uc_GetPatternProperties As Long = 66

Public Const uc_GetTrigMode As Long = 67
Public Const uc_SetTrigMode As Long = 68

Public Const uc_ItemClone As Long = 70
Public Const uc_DataConvert As Long = 71
Public Const uc_DataCopy As Long = 72
Public Const uc_DataAlloc As Long = 72
Public Const uc_DataFree As Long = 73
Public Const uc_DataReset As Long = 74

Public Const uc_SetFPU As Long = 75
Public Const uc_SetFPU_HostProg As Long = 76
Public Const uc_GetFPU As Long = 77
Public Const uc_GetFPU_HostProg As Long = 78
Public Const uc_ToggleFPU As Long = 79
Public Const uc_ToggleFPU_HostProg As Long = 80
Public Const uc_ErrorClear As Long = 85

Public Const uc_SetErrorMessage As Long = 91
Public Const uc_GetErrorMessage As Long = 92

Public Const uc_SerialNumber As Long = 93
Public Const uc_SetTurbo As Long = 94
Public Const uc_Expand As Long = 95
Public Const uc_GetNextItem As Long = 96
Public Const uc_GetItemData As Long = 97
Public Const uc_SetItemData As Long = 98
Public Const uc_GetThreadAddr As Long = 99
Public Const uc_GetCodeBlock As Long = 100

Public Const uc_Properties As Long = 1
Public Const uc_Thread As Long = 2
Public Const uc_Address As Long = 3
Public Const uc_SymbolName As Long = 4
Public Const uc_Rank As Long = 5
Public Const uc_Precedence As Long = 6
Public Const uc_OverloadHandle As Long = 7
Public Const uc_OverloadCount As Long = 8
Public Const uc_ByteSize As Long = 9
Public Const uc_ArgCount As Long = 10
Public Const uc_DataType As Long = 12
Public Const uc_Handle As Long = 13
Public Const uc_Value As Long = 14
Public Const uc_Property As Long = 15

' Error numbers
Public Const uc_Err_None As Long = 0
Public Const uc_Err_Dynamically_Defined As Long = 1
Public Const uc_Err_Syntax_Error As Long = 2
Public Const uc_Err_Undefined_Identifier As Long = 3
Public Const uc_Err_Unknown_Error As Long = 4
Public Const uc_Err_Unrecognized_Pattern As Long = 5
Public Const uc_Err_Unrecognized_Command As Long = 6
Public Const uc_Err_Datatype_Mismatch As Long = 7
Public Const uc_Err_Invalid_Argument_Count As Long = 8
Public Const uc_Err_Invalid_Definition As Long = 9
Public Const uc_Err_CodeBlock_Error As Long = 10
Public Const uc_Err_Undefined_Callback As Long = 11
Public Const uc_Err_ErrMsgAlreadyDefined = 12
Public Const uc_Err_ItemCannotBeModified = 13
Public Const uc_Err_Unrecognized_Member = 14

Public Const uc_Err_Array_Bounds_Exceeded As Long = 20
Public Const uc_Err_Float_Denormal_Operand As Long = 21
Public Const uc_Err_Float_Divide_By_Zero As Long = 22
Public Const uc_Err_Float_Inexact_Result As Long = 23
Public Const uc_Err_Float_Invalid_Operation As Long = 24
Public Const uc_Err_Float_Overflow As Long = 25
Public Const uc_Err_Float_Stack_Check As Long = 26
Public Const uc_Err_Float_Underflow As Long = 27
Public Const uc_Err_Integer_Divide_By_Zero As Long = 28
Public Const uc_Err_Integer_Overflow As Long = 29
Public Const uc_Err_Privileged_Instruction As Long = 30

' FPU Control Word Settings
Public Const uc_FPU_Mask_InvalidOp As Long = 1
Public Const uc_FPU_Mask_DenormalOp As Long = 2
Public Const uc_FPU_Mask_ZeroDivide As Long = 4
Public Const uc_FPU_Mask_Overflow As Long = 8
Public Const uc_FPU_Mask_Underflow As Long = 16
Public Const uc_FPU_Mask_PrecisionLoss As Long = 32

Public Const uc_FPU_Precision_Single As Long = 0
Public Const uc_FPU_Precision_Double As Long = 256
Public Const uc_FPU_Precision_Extended As Long = 768

Public Const uc_FPU_Round_Even As Long = 0
Public Const uc_FPU_Round_Down As Long = 1024
Public Const uc_FPU_Round_Up As Long = 2048
Public Const uc_FPU_Round_Toward As Long = 3072


Public Const ucAbort As Long = 0
Public Const ucResume As Long = 1
Public Const ucReRaise As Long = 2

' Data type handler callback action modes
Public Const uc_TypeHandler_Store As Long = 2
Public Const uc_TypeHandler_StringOutput As Long = 3
Public Const uc_TypeHandler_Free As Long = 4
Public Const uc_TypeHandler_FuncRet As Long = 5
Public Const uc_TypeHandler_Copy As Long = 6
Public Const uc_TypeHandler_Alloc As Long = 7
Public Const uc_TypeHandler_Reset As Long = 8

Public Const uc_Callback_Undefined As Long = 0
' Returns error

' Data Type callbacks
Public Const uc_Complex As Long = 1
Public Const uc_Currency As Long = 2
Public Const uc_Double As Long = 3
Public Const uc_Extended As Long = 4
Public Const uc_Int8 As Long = 5
Public Const uc_Int8u As Long = 6
Public Const uc_Int16 As Long = 7
Public Const uc_Int16u As Long = 8
Public Const uc_Int32 As Long = 9
Public Const uc_Int32u As Long = 10
Public Const uc_Int64 As Long = 11
Public Const uc_Int64u As Long = 12
Public Const uc_Single As Long = 13
Public Const uc_String As Long = 14
Public Const uc_String_LPCSTR As Long = 15
Public Const uc_String_Fixed As Long = 16
Public Const uc_String_Wide As Long = 17
Public Const uc_Stack As Long = 18
Public Const uc_Void As Long = 19
Public Const uc_User_Type = 20

Public Const uc_Convert_Generic As Long = 23
Public Const uc_Convert_Double_Extended As Long = 24
Public Const uc_Convert_Int8_Extended As Long = 25
Public Const uc_Convert_Int8u_Extended As Long = 26
Public Const uc_Convert_Int16_Extended As Long = 27
Public Const uc_Convert_Int16u_Extended As Long = 28
Public Const uc_Convert_Int32_Extended As Long = 29
Public Const uc_Convert_Int32u_Extended As Long = 30
Public Const uc_Convert_Int64_Extended As Long = 31
Public Const uc_Convert_Int64u_Extended As Long = 32
Public Const uc_Convert_Single_Extended As Long = 33
Public Const uc_Convert_Extended_Double As Long = 37
Public Const uc_Convert_Extended_Single As Long = 38
Public Const uc_Convert_Extended_Int16u As Long = 39
Public Const uc_Convert_Extended_Int32 As Long = 40
Public Const uc_Convert_Complex_Extended As Long = 41
Public Const uc_Convert_Extended_Complex As Long = 42

' Default built-in routines.

Public Const uc_Op_Negate_Extended As Long = 43
Public Const uc_Op_UnaryPlus_Extended As Long = 44
Public Const uc_Op_Percentage_Extended As Long = 45
Public Const uc_Op_StrConcat As Long = 46
Public Const uc_Op_Add_Int32 As Long = 47
Public Const uc_Op_Add_Extended As Long = 48
Public Const uc_Op_Add_Complex As Long = 49
Public Const uc_Op_Subtract_Int32 As Long = 50
Public Const uc_Op_Subtract_Extended As Long = 51
Public Const uc_Op_Multiply_Int32 As Long = 52
Public Const uc_Op_Multiply_Extended As Long = 53
Public Const uc_Op_Multiply_Complex As Long = 54
Public Const uc_Op_Divide_Int32 As Long = 55
Public Const uc_Op_Divide_Extended As Long = 56
Public Const uc_Op_Mod_Int32 As Long = 57
Public Const uc_Op_Mod_Extended As Long = 58
Public Const uc_Op_PowerOf_ExtToExt As Long = 59
Public Const uc_Op_PowerOf_ExtToLng As Long = 60
Public Const uc_Op_PowerOf_CplxToCplx As Long = 61

Public Const uc_Op_GreaterThan_Extended As Long = 62
Public Const uc_Op_GreaterOrEqual_Extended As Long = 63
Public Const uc_Op_LessThan_Extended As Long = 64
Public Const uc_Op_LessOrEqual_Extended As Long = 65
Public Const uc_Op_Equal_Extended As Long = 66
Public Const uc_Op_NotEqual_Extended As Long = 67

Public Const uc_Op_GreaterThan_Str As Long = 68
Public Const uc_Op_GreaterOrEqual_Str As Long = 69
Public Const uc_Op_LessThan_Str As Long = 70
Public Const uc_Op_LessOrEqual_Str As Long = 71
Public Const uc_Op_Equal_Str As Long = 72
Public Const uc_Op_NotEqual_Str As Long = 73

Public Const uc_Op_Not_Int32 As Long = 74
Public Const uc_Op_And_Int32 As Long = 75
Public Const uc_Op_Or_Int32 As Long = 76
Public Const uc_Op_Xor_Int32 As Long = 77
Public Const uc_Op_Eqv_Int32 As Long = 78
Public Const uc_Op_Imp_Int32 As Long = 79

Public Const uc_Op_AndAlso As Long = 80
Public Const uc_Op_OrElse As Long = 81

Public Const uc_Op_Factorial As Long = 82

Public Const uc_Func_IIf As Long = 83
Public Const uc_Func_IIf_Str As Long = 84

Public Const uc_Func_Sin As Long = 85
Public Const uc_Func_Cos As Long = 86
Public Const uc_Func_Tan As Long = 87
Public Const uc_Func_Atan As Long = 88
Public Const uc_Func_Ceil As Long = 89
Public Const uc_Func_Abs_Extended As Long = 90
Public Const uc_Func_Abs_Int32 As Long = 91
Public Const uc_Func_Exp As Long = 92
Public Const uc_Func_Log As Long = 93
Public Const uc_Func_Floor As Long = 94
Public Const uc_Func_SquareRoot As Long = 95
Public Const uc_Func_BaseConvert As Long = 96

Public Const uc_Func_ExprHandle As Long = 97
Public Const uc_Func_VarPtr As Long = 98
Public Const uc_Func_uCalc As Long = 99
Public Const uc_Func_uCalcStr As Long = 100
Public Const uc_Func_ucAddr As Long = 101
Public Const uc_Func_ValueAtAddr As Long = 102

Public Const uc_Func_Asc As Long = 103
Public Const uc_Func_Chr As Long = 104

Public Const uc_Func_For As Long = 105
Public Const uc_Func_Loop As Long = 107

Public Const uc_Func_LoadLibrary As Long = 108
Public Const uc_Func_GetProcAddress As Long = 109

Public Const uc_NullString As Long = 110
Public Const uc_True As Long = 111

Public Const uc_Func_Peek = 112
Public Const uc_Func_Poke = 113

Public Const uc_Func_Int As Long = 115
Public Const uc_Func_Frac As Long = 116
Public Const uc_Func_Sgn As Long = 117

Public Const uc_Func_PushData_Stack As Long = 120
' Public Const uc_Func_PopHandle_Stack As Long = 121
Public Const uc_Func_PopNum_Stack As Long = 122
Public Const uc_Func_PopStr_Stack As Long = 123
Public Const uc_Func_ReadHandle_Stack As Long = 124
Public Const uc_Func_ReadNum_Stack As Long = 125
Public Const uc_Func_ReadStr_Stack As Long = 126
Public Const uc_Func_Count_Stack As Long = 127
Public Const uc_Op_Concat_Stack As Long = 128
Public Const uc_Func_Populate_Stack As Long = 129

Public Const uc_Insert_Table As Long = 130
Public Const uc_Delete_Table As Long = 131
Public Const uc_Index_Table As Long = 132
Public Const uc_Handle_Table As Long = 133
Public Const uc_HandleB_Table As Long = 134

Public Const uc_Func_StackFormat As Long = 135

Public Const uc_SetVariableValue As Long = 140
Public Const uc_SetVariableValueAnyType As Long = 140
Public Const uc_SetVariableValueLong As Long = 141
Public Const uc_SetVariableValueDouble As Long = 142
Public Const uc_SetVariableValueExtended As Long = 143

' Misc other callbacks
Public Const uc_EvaluateAddr As Long = 150
Public Const uc_EvaluateTurboAddr As Long = 151
Public Const uc_ExceptionHelper As Long = 152
Public Const uc_DefaultErrorHandler As Long = 153
Public Const uc_Raise_Error As Long = 154

' Interpreter addresses
Public Const uc_Interp_DefHandle As Long = 160     ' DWord Ptr
Public Const uc_Interp_ExitCommand As Long = 161   ' String Ptr
Public Const uc_Interp_LastResultNum As Long = 163 ' Extended Ptr
Public Const uc_Interp_LastResultStr As Long = 164 ' String Ptr
Public Const uc_Interp_LineContinue As Long = 165
Public Const uc_Interp_MainPrompt As Long = 166
Public Const uc_Interp_MultiLinePrompt As Long = 167
Public Const uc_Interp_Prefix As Long = 168
Public Const uc_Interp_Postfix As Long = 169
Public Const uc_Interp_Tab As Long = 170
Public Const uc_Interp_Insert As Long = 171

Public Const uc_Op_Ext_Plus_Complex As Long = 190
Public Const uc_Op_Ext_Times_Complex As Long = 191

Public Const uc_Func_If_ElseIf As Long = 195
Public Const uc_Func_SetSyntaxParams As Long = 196
Public Const uc_Func_SpecialUCase As Long = 197
Public Const uc_Func_Rand As Long = 198
Public Const uc_Func_Batch_Eval As Long = 199

Public Const uc_Op_Add_Double As Long = 201
Public Const uc_Op_Subtract_Double As Long = 202
Public Const uc_Op_Multiply_Double As Long = 203
Public Const uc_Op_Divide_Double As Long = 204
Public Const uc_Op_Mod_Double As Long = 205
Public Const uc_Op_PowerOf_DblToDbl As Long = 206
Public Const uc_Op_PowerOf_DblToLng As Long = 207

Public Const uc_Func_Sin_Dbl As Long = 208
Public Const uc_Func_Cos_Dbl As Long = 209
Public Const uc_Func_Tan_Dbl As Long = 210
Public Const uc_Func_Atan_Dbl As Long = 211
Public Const uc_Func_Ceil_Dbl As Long = 212
Public Const uc_Func_Abs_Dbl As Long = 213
Public Const uc_Func_Exp_Dbl As Long = 214
Public Const uc_Func_Log_Dbl As Long = 215
Public Const uc_Func_SquareRoot_Dbl As Long = 216

Public Const uc_Convert_Double_Int32 As Long = 218
Public Const uc_Convert_Int32_Double As Long = 219

Public Const ucTrue As Long = 1
Public Const ucFalse As Long = 0

Public Const uc_First As Long = 1
Public Const uc_Last As Long = -1

' Trig Modes
Public Const uc_ReturnTrigMode = 0
Public Const uc_Radians = 1
Public Const uc_Degrees = 2
Public Const uc_Grad = 3

' End Of Constants

Public ucIsInitialized As Long
Public ucExtended As Long, ucDouble As Long, ucSingle As Long
Public ucString As Long, ucWideString As Long, ucLPCSTR As Long, ucFixedString As Long
Public ucLong As Long, ucDword As Long, ucComplex As Long, ucByte As Long, ucTable As Long, ucVoid As Long, ucStack As Long
Public ucSortedList As Long

Public Declare Function uCalc_ Lib "ucFMP296.dll" Alias "uCalc" (ByVal ucCommand As Long, _
       ByVal TextArg As String, ByVal MiscArg1 As Long, ByVal MiscArg2 As Long, _
       ByVal ReturnPtr As Long, ByVal t As Long) As Long
       
Public Declare Function uCalc__ Lib "ucFMP296.dll" Alias "uCalc" (ByVal ucCommand As Long, _
       ByVal TextArg As Long, ByVal MiscArg1 As Long, ByVal MiscArg2 As Long, _
       ByVal ReturnPtr As Long, ByVal t As Long) As Long

Public Declare Function ucEvaluate Lib "ucFMP296.dll" Alias "ucEvaluateDbl" (ByVal Item As Long) As Double
Public Declare Function ucExprThread Lib "ucFMP296.dll" (ByVal Expr As Long) As Long
Public Declare Function ucParam Lib "ucFMP296.dll" Alias "ucParamDbl" (ByVal Expr As Long, ByVal pIndex As Long) As Double
Public Declare Function ucParamDbl Lib "ucFMP296.dll" (ByVal Expr As Long, ByVal pIndex As Long) As Double
Public Declare Function ucParamStr Lib "ucFMP296.dll" (ByVal Expr As Long, ByVal pIndex As Long) As String
Public Declare Function ucParamHandle Lib "ucFMP296.dll" (ByVal Expr As Long, ByVal pIndex As Long) As Long
Public Declare Function ucParamCount Lib "ucFMP296.dll" (ByVal Expr As Long) As Long
Public Declare Function ucStrReturn Lib "ucFMP296.dll" (ByVal TextPtr As Long) As String
Public Declare Sub ucReturn Lib "ucFMP296.dll" Alias "ucReturnDbl" (ByVal Expr As Long, ByVal ReturnValue As Double)
Public Declare Sub ucReturnDbl Lib "ucFMP296.dll" (ByVal Expr As Long, ByVal ReturnValue As Double)
Public Declare Sub ucReturnStr Lib "ucFMP296.dll" (ByVal Expr As Long, ByVal ReturnValue As String)
Public Declare Sub ucSetVariableValue Lib "ucFMP296.dll" Alias "ucSetVariableValueDbl" _
       (ByVal Item As Long, ByVal NewValue As Double)
Public Declare Sub ucSetVariableValueStr Lib "ucFMP296.dll" (ByVal Item As Long, ByVal NewValue As String)

Public Function uCalc(ByVal ucCommand As Long, Optional TextArg As String = "", _
               Optional ByVal MiscArg1 As Long = 0, Optional ByVal MiscArg2 As Long = 0, _
               Optional ByVal ReturnPtr As Long = 0, Optional ByVal t As Long = 0) As Long
   If ucIsInitialized = ucFalse Then Call ucInitialize
   uCalc = uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t)
End Function

Public Function uCalcB(ByVal ucCommand As Long, Optional ByVal TextArg As Long = 0, _
               Optional ByVal MiscArg1 As Long = 0, Optional ByVal MiscArg2 As Long = 0, _
               Optional ByVal ReturnPtr As Long = 0, Optional ByVal t As Long = 0) As Long
   If ucIsInitialized = ucFalse Then Call ucInitialize
   uCalcB = uCalc__(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t)
'  NOTE: Make sure you place the uCalc DLL files in a directory that's in the path
End Function

Public Function uCalcStr(ByVal ucCommand As Long, Optional TextArg As String = "", _
               Optional ByVal MiscArg1 As Long = 0, Optional ByVal MiscArg2 As Long = 0, _
               Optional ByVal ReturnPtr As Long = 0, Optional ByVal t As Long = 0) As String
   If ucIsInitialized = ucFalse Then Call ucInitialize
   uCalcStr = ucStrReturn(uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t))
End Function

Public Function ucAddr(ByVal AddressIndex As Long) As Long
   ucAddr = uCalcB(uc_GetCodeAddr, 0, AddressIndex)
End Function

Public Function ucDefine(Definition As String, Optional ByVal Arg1 As Long = 0, Optional ByVal Arg2 As Long = 0, _
                  Optional ByVal Arg3 As Long = 0, Optional ByVal t As Long = 0) As Long
   ucDefine = uCalc(uc_Define, Definition, Arg1, Arg2, Arg3, t)
End Function

Public Function ucDefineFunction(Definition As String, Optional ItemAddress As Long = 0, Optional ByVal t As Long = 0) As Long
   Dim ItemDef$
   ItemDef$ = "Func: " + Definition
   If ItemAddress Then ItemDef$ = ItemDef$ + " At " + Str$(ItemAddress)
   ucDefineFunction = uCalc(uc_Define, ItemDef$, 0, 0, 0, t)
End Function

Public Function ucDefineOperator(Definition As String, Optional ItemAddress As Long = 0, Optional ByVal t As Long = 0) As Long
   Dim ItemDef$
   ItemDef$ = "Op: " + Definition
   If ItemAddress Then ItemDef$ = ItemDef$ + " At " + Str$(ItemAddress)
   ucDefineOperator = uCalc(uc_Define, ItemDef$, 0, 0, 0, t)
End Function

Public Function ucDefineSyntax(Definition As String, Optional ByVal Rank As Long = 1, Optional ByVal t As Long = 0) As Long
   ucDefineSyntax = uCalc(uc_DefineSyntax, Definition, Rank, 0, 0, t)
End Function

Public Function ucDefineVariable(Definition As String, Optional ItemAddress As Long = 0, Optional ByVal t As Long = 0) As Long
   Dim ItemDef$
   ItemDef$ = "Var: " + Definition
   If ItemAddress Then ItemDef$ = ItemDef$ + " At " + Str$(ItemAddress)
   ucDefineVariable = uCalc(uc_Define, ItemDef$, 0, 0, 0, t)
End Function

Public Function ucEval(Expr As String, Optional ByVal t As Long = 0) As Double
   Dim Answer As Double

   uCalc uc_EvalDbl, Expr, 0, 0, VarPtr(Answer), t
   ucEval = Answer
End Function

Public Function ucEvalStr(Expr As String, Optional ByVal ExprType As Long = 0, Optional ByVal t As Long = 0) As String
   ucEvalStr = uCalcStr(uc_EvalStr, Expr, ExprType, 0, 0, t)
End Function

Public Function ucEvaluateStr(ByVal Item As Long) As String
   ucEvaluateStr = ucStrReturn(uCalcB(uc_EvaluateStr, 0, Item))
End Function

Public Function ucExpand(Expr As String, Optional ByVal t As Long = 0) As String
   ucExpand = uCalcStr(uc_Expand, Expr, 0, 0, 0, t)
End Function

Public Function ucErrorMessage(Optional ByVal ErrNum As Long = 0, Optional ByVal t As Long = 0) As String
   ucErrorMessage = ucStrReturn(uCalcB(uc_GetErrorMessage, 0, ErrNum, 0, 0, t))
End Function

Public Function ucGetError(Optional ByVal t As Long = 0) As Long
   ucGetError = uCalcB(uc_GetErrorNumber, 0, 0, 0, 0, t)
End Function
Public Function ucError(Optional ByVal t As Long = 0) As Long
   ucError = uCalcB(uc_GetErrorNumber, 0, 0, 0, 0, t)
End Function
Public Function ucRaiseError(ByVal Expr As Long, ByVal ErrorNum As Long) As Long
   ucRaiseError = uCalcB(uc_SetErrorNumber, 0, ErrorNum, Expr, 0, ucExprThread(Expr))
End Function
Public Sub ucRaiseErrorMessage(ByVal Expr As Long, ErrMessage As String)
   uCalc uc_SetErrorMessage, ErrMessage, uc_Err_Dynamically_Defined, 0, 0, ucExprThread(Expr)
   uCalcB uc_SetErrorNumber, 0, uc_Err_Dynamically_Defined, Expr, 0, ucExprThread(Expr)
End Sub
Public Function ucSetError(ByVal ErrorNum As Long, Optional ByVal t As Long = 0) As Long
   ucSetError = uCalcB(uc_SetErrorNumber, 0, ErrorNum, 0, 0, t)
End Function
Public Function ucErrLocation(ByVal t As Long) As Long
   ucErrLocation = uCalc(uc_GetLocation, 0, 0, 0, 0, t)
End Function
Public Function ucErrSymbol(ByVal t As Long) As String
   ucErrSymbol = uCalcStr(uc_GetSymbol, 0, 0, 0, 0, t)
End Function

Public Function ucGetCodeBlock(Expr As String, ByRef i As Long, Optional ByVal ucOption As Long = 0, Optional ByVal t As Long = 0) As String
   ucGetCodeBlock = uCalcStr(uc_GetCodeBlock, StrPtr(Expr), 0, ucOption, VarPtr(i), t)
End Function

Public Function ucGetExpr(Optional t As Long = 0) As String
   ucGetExpr = ucStrReturn(uCalcB(uc_GetExpression, 0, 0, 0, 0, t))
End Function

Public Function ucGetItemHandle(SymbolName As String, Optional ByVal ucProperties As Long = 0, Optional ByVal t As Long = 0) As Long
   ucGetItemHandle = uCalc(uc_GetItemData, SymbolName, 0, uc_Handle, ucProperties, t)
End Function

Public Function ucGetNextItem(Expr As String, ByRef i As Long, Optional ByVal ucOption As Long = 0, Optional ByVal t As Long = 0) As String
   ucGetNextItem = uCalcStr(uc_GetNextItem, Expr, 0, ucOption, VarPtr(i), t)
End Function

Public Function ucGetSymbol(ByVal t As Long) As String
   ucGetSymbol = ucStrReturn(uCalcB(uc_GetSymbol, 0, 0, 0, 0, t))
End Function

Public Function ucGetTrigMode() As Long
   ucGetTrigMode = uCalc(uc_GetTrigMode)
End Function

Public Function ucInterpret(Expr As String, Optional ByVal ExprType As Long = 0, Optional ByVal t As Long = 0) As String
   ucInterpret = uCalcStr(uc_EvalStr, Expr, ExprType, 1, 0, t)
End Function

Function ucLicense(ByVal LicenseOption As Long, Optional ByVal L1 As Long = 0, Optional ByVal L2 As Long = 0, Optional ByVal L3 As Long = 0) As Long
   uCalc__ uc_License, L1, LicenseOption, L2, L3, 0
End Function

Public Function ucNewThread(Optional ByVal ParentThread As Long = 0) As Long
   ucNewThread = uCalcB(uc_NewThread, 0, ParentThread)
End Function

Public Function ucParse(Expr As String, Optional ByVal ExprType As Long = 0, Optional ByVal t As Long = 0) As Long
   ucParse = uCalc(uc_Parse, Expr, ExprType, 0, 0, t)
End Function

Public Function ucReleaseItem(ByVal ucItem As Long) As Long
   ucReleaseItem = uCalcB(uc_ReleaseItem, 0, ucItem)
End Function

Public Function ucSetErrMsg(ByVal ErrIndex As Long, ErrMessage As String, Optional ByVal t As Long = 0) As Long
   ucSetErrMsg = uCalc(uc_SetErrorMessage, ErrMessage, ErrIndex, 0, 0, t)
End Function

Public Function ucSetErrorNumber(ByVal ErrorNumber As Long, Optional ByVal t As Long = 0) As Long
   ucSetErrorNumber = uCalcB(uc_SetErrorNumber, 0, ErrorNumber, 0, 0, t)
End Function

Public Sub ucSetTrigMode(ByVal TrigMode As Long)
   uCalc uc_SetTrigMode, 0, TrigMode
End Sub

Public Function ucInitialize() As Long
   ucIsInitialized = ucTrue

   ucInitialize = ucLicense(uc_License_Demo)

   ucSetErrMsg uc_Err_None, "No error"
   ucSetErrMsg uc_Err_Syntax_Error, "Syntax error"
   ucSetErrMsg uc_Err_Undefined_Identifier, "Undefined identifier"
   ucSetErrMsg uc_Err_Unknown_Error, "Unknown error"
   ucSetErrMsg uc_Err_Unrecognized_Pattern, "Unrecognized pattern"
   ucSetErrMsg uc_Err_Unrecognized_Command, "Unrecognized command"
   ucSetErrMsg uc_Err_Datatype_Mismatch, "Data type mismatch"
   ucSetErrMsg uc_Err_CodeBlock_Error, "Code block delimiter error"
   ucSetErrMsg uc_Err_Invalid_Argument_Count, "Invalid number of arguments"
   ucSetErrMsg uc_Err_Invalid_Definition, "Invalid definition"
   ucSetErrMsg uc_Err_Undefined_Callback, "Undefined callback"
   ucSetErrMsg uc_Err_ErrMsgAlreadyDefined, "Error message already defined"
   ucSetErrMsg uc_Err_ItemCannotBeModified, "This item cannot be modified"
   ucSetErrMsg uc_Err_Unrecognized_Member, "Unrecognized member"
   ucSetErrMsg uc_Err_Array_Bounds_Exceeded, "Array bounds exceeded"
   ucSetErrMsg uc_Err_Float_Denormal_Operand, "Denormal operand"
   ucSetErrMsg uc_Err_Float_Divide_By_Zero, "Division by 0"
   ucSetErrMsg uc_Err_Float_Inexact_Result, "Inexact result"
   ucSetErrMsg uc_Err_Float_Invalid_Operation, "Invalid operation"
   ucSetErrMsg uc_Err_Float_Overflow, "Floating point overflow"
   ucSetErrMsg uc_Err_Float_Stack_Check, "Floating point stack error"
   ucSetErrMsg uc_Err_Float_Underflow, "Floating point underflow"
   ucSetErrMsg uc_Err_Integer_Divide_By_Zero, "Integer division by 0"
   ucSetErrMsg uc_Err_Integer_Overflow, "Integer overflow"
   ucSetErrMsg uc_Err_Privileged_Instruction, "Privileged instruction denied"

   ' Extended, Double, and Single must be defined in that order, and prior to other types.
   ucExtended = ucDefine("DataType: Extended ~~ Size: 10 ~~ TypeHandler: #", ucAddr(uc_Extended))
   ucDouble = ucDefine("DataType: Double ~~ Size: 8 ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Double), ucAddr(uc_Convert_Double_Extended))
   ucSingle = ucDefine("DataType: Single ~~ Size: 4 ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Single), ucAddr(uc_Convert_Single_Extended))
   ucLong = ucDefine("DataType: Long     ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Int32), ucAddr(uc_Convert_Int32_Extended))
   ucDword = ucDefine("DataType: Dword    ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Int32u), ucAddr(uc_Convert_Int32u_Extended))
   ucString = ucDefine("DataType: String   ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: LPCSTR", ucAddr(uc_String))
   ucWideString = ucDefine("DataType: WideString ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: String", ucAddr(uc_String_Wide))
   ucString = ucDefine("DataType: String ~~ ConvertsTo: WideString")

   ucFixedString = ucDefine("DataType: FixedString ~~ TypeHandler: # ~~ ConvertsTo: String ~~ ConvertsFrom: String", ucAddr(uc_String_Fixed))
   ucByte = ucDefine("DataType: Byte     ~~ Size: 1  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Int8u), ucAddr(uc_Convert_Int8u_Extended))
   ucLPCSTR = ucDefine("DataType: LPCSTR               ~~ TypeHandler: # ~~ ConvertsTo: String", ucAddr(uc_String_LPCSTR))
   ucStack = ucDefine("DataType: Stack    ~~ Size: 4  ~~ TypeHandler: #", ucAddr(uc_Stack))
   ucSortedList = ucDefine("DataType: SortedList ~~ Size: 4  ~~ TypeHandler: #", ucAddr(uc_Stack))
   ucTable = ucDefine("DataType: Table    ~~ Size: 4      ~~ TypeHandler: #", ucAddr(uc_Stack))
   ucVoid = ucDefine("DataType: Void     ~~ Size: 10 ~~ TextData: Ok ~~ TypeHandler: #", ucAddr(uc_Void))

   ucDefine "DataType: Double ~~ ConvertsFrom: Single ~~ ConvertsTo: Single"
   ucDefine "DataType: Double ~~ ConvertsFrom: Byte ~~ ConvertsTo: Byte"
   ucDefine "DataType: Double ~~ ConvertsTo: Long, #", ucAddr(uc_Convert_Double_Int32)
   ucDefine "DataType: Long   ~~ ConvertsTo: Double, #", ucAddr(uc_Convert_Int32_Double)
   ucDefine "DataType: Double ~~ ConvertsFrom: Dword ~~ ConvertsTo: Dword"

   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Long, #", ucAddr(uc_Convert_Extended_Int32))
   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Dword, #", ucAddr(uc_Convert_Extended_Int32))
   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Double, #", ucAddr(uc_Convert_Extended_Double))
   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Byte")

   ucDword = ucDefine("DataType: Dword ~~ ConvertsTo: Long")   

   ucDefine "Pattern:[\x00\x01\x02]" ' Reserved characters
   ucDefine "Pattern:\x03 ~~ \x03 ~~ DataType: #2", ucQuotedText + ucLiteral, ucString
   ucDefine "Pattern:\x05" ' Define Codeblock bootstrap
   ucDefine "Pattern:\x06 ~~ \x07", ucCodeBlock
   ucDefine "Pattern: :"
   ucDefine "Pattern: :="
   ucDefine "Pattern:\[ ~~ \]", ucCodeBlock
   ucDefine "Pattern:\{ ~~ \} ~~ DataType: #2 ~~ Address: #3", ucCodeBlock, ucStack, ucAddr(uc_Func_Populate_Stack)
   ucDefine "Pattern:[\q] ~~ [\q] ~~ DataType: #2", ucQuotedText + ucLiteral, ucString
   ucDefine "Pattern:['] ~~ ['] ~~ DataType: #2", ucQuotedText + ucLiteral, ucString
   ucDefine "Pattern:\x0D\x0A", ucStatementSep ' Carriage Return
   ucDefine "Pattern:;", ucStatementSep
   ucDefine "Pattern:~t", ucCurrentThread
   ucDefine "Pattern:~Eval", ucEvalInsert
   ucDefine "Pattern:~Eval_1 ~~ PassOnce", ucEvalInsert
   ucDefine "Pattern:~Eval_P", ucEvalDuringParse
   ucDefine "Pattern:~Expand", ucExpandInsert
   ucDefine "Pattern:~Expand_1 ~~ PassOnce", ucExpandInsert
   ucDefine "Pattern:\.", ucMemberAccess
   ucDefine "Pattern:\~\~"
   ucDefine "Pattern:,", ucArgSeparator
   ucDefine "Pattern:\( ~~ \)", ucCodeBlock
   ucDefine "Pattern:[ \t]+", ucWhiteSpace
   ucDefine "Pattern:[\|+/*^$&#\-=%@!`\\<>?]+", ucReducible  ' For operators
   ucDefine "Pattern:([0-9]*\.)?[0-9]+(e[-+]?[0-9]+)? ~~ DataType: #2", ucLiteral, ucDouble ' Numeric
   ucDefine "Pattern:[a-z_][0-9a-z_]* ~~ Name: AlphaNum", ucAlphaNumeric

   ucDefineSyntax "Op: {Name} '{' {Operand} '}' [As {type}] ::=" _
                 + "Param: {Operand} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(ucPrefix + ucOperator)
   ucDefineSyntax "Op: '{' {Operand} '}' {Name} [As {type}] ::=" _
                 + "Param: {Operand} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(ucPostfix + ucOperator)
   ucDefineSyntax "Op: '{' {LeftOp} '}' {Name} '{' {RightOp} '}' [As {type}] ::=" _
                 + "Param: {LeftOp} ~~ Param: {RightOp} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(ucInfix + ucOperator)

   ucDefineSyntax "Op: {Def} { At {addr} | ':=' {Expr:'.+'} } ::= Op: {Def} {addr: ~~ Address: {addr} ~~ StdCall} {Expr: ~~ FuncBody: {Expr}}"
   ucDefineSyntax "Op: {pValue:' *[0-9]+ '} {Def} ::= Precedence: {pValue} ~~ Op: {Def}"
   ucDefineSyntax "Op: Precedence({op}) ::= Op: ~Eval(Precedence({op}))"
   ucDefineSyntax "Op:: {Def:'.+'} ::= NativeCall ~~ Address: # ~~ Op: {Def}"
   ucDefineSyntax "Op: Native: {Def} At {Addr} ::= NativeCall ~~ Address: {Addr} ~~ Op: {Def}"

   ucDefineSyntax "Var: {VarName:'[ ]*[a-z_][0-9a-z_]*'} [As {Type}] [= {Value}] [At {Addr:' .+'}] ::=" _
                  + "Variable ~~ Name: {VarName}" _
                  + "{Type: ~~ DataType: {Type}}" _
                  + "{Value: ~~ Value: {Value}}" _
                  + "{Addr: ~~ Address: {Addr}}"
   ucDefineSyntax "Var: {VarName:'[ ]*[a-z_][0-9a-z_]*'} As AnyType ::= AnyType ~~ Var: {VarName}"
   ucDefineSyntax "Var: {PassBy:'( +ByRef)|( +ByVal)|( +ByHandle)|( +ByExpr)'} ::= {PassBy} ~~ Var:"
   ucDefineSyntax "Var: {Def} ... ::= Var: {Def} ~~ VariableArgList"
   ucDefineSyntax "Var: ... ::= Var: _ ~~ VariableArgList"
   ucDefineSyntax "Var: {name:' *[_a-z]*'} = {quote:' *[\x22\x27]'} ::= Var: {name} As String = {quote}"

   ucDefineSyntax "Const: {Def:'.*'} ::= Var: {Def} ~~ Properties: " + Str$(ucLock)
   ucDefineSyntax "=- ::= = -"

   ucDefineSyntax "Func: {FuncName} ([{ParamList}]) [As {type:' +[a-z]+[a-z0-9]*'}] [{ At {addr} | = {Def:'.+'} }] ::= " _
                  + "Params: ({ParamList}) ~~ Name: {FuncName} ~~ DataType: {type}" _
                  + "~~ Properties: " + Str$(ucFunction + ucPrefix) _
                  + "{addr: ~~ Address: {addr} ~~ StdCall} ~~ FuncBody: {Def}"

   ucDefineSyntax "Func:: {Def:'.+'} ::= NativeCall ~~ Address: # ~~ Func: {Def}"
   ucDefineSyntax "Func: Native: {Def} At {Addr} ::= NativeCall ~~ Address: {Addr} ~~ Func: {Def}"


   ucDefineSyntax "Params: ([{SingleParam}]) ::= IsParam ~~ { {SingleParam: Var: {SingleParam}} }"
   ucDefineSyntax "Params: ({Variable} = {Default}) ::= Params: ({Variable} ~~ TextData: {Default})"
   ucDefineSyntax "Params: ({Param1}, {OtherParams}) ::= Params: ({Param1}) ~~ Params: ({OtherParams})"
   ucDefineSyntax "Param: {ParamDef} ~~ ::= IsParam ~~ { Var: {ParamDef} } ~~"

   ucDefine "Op:: -{x}    ~~ Precedence: 25", ucAddr(uc_Op_Negate_Extended)
   ucDefine "Op:: {x As String}+{y As String} As String ~~ Precedence: 10", ucAddr(uc_Op_StrConcat)
   ucDefine "Op:: {x As Long}+{y As Long} As Long ~~ Precedence: 10", ucAddr(uc_Op_Add_Int32)

   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Complex, #", ucAddr(uc_Convert_Extended_Complex))
   ucComplex = ucDefine("DataType: Complex ~~ {Var: Real As Extended} ~~ {Var: Imag As Extended = 1} ~~ TypeHandler: #", ucAddr(uc_Complex))
   ucDefine "Pattern:#i ~~ DataType: #2", ucLiteral, ucComplex
   ucDefine "Op:: {x As Complex}+{y As Complex} As Complex ~~ Precedence: 10", ucAddr(uc_Op_Add_Complex)
   ucDefine "Op:: {x As Complex}*{y As Complex} As Complex ~~ Precedence: 10", ucAddr(uc_Op_Multiply_Complex)

   ucDefine "Op:: {x}>{y}  As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterThan_Extended)
   ucDefine "Op:: {x}<{y}  As Long ~~ Precedence: 5", ucAddr(uc_Op_LessThan_Extended)
   ucDefine "Op:: {x}>={y} As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterOrEqual_Extended)
   ucDefine "Op:: {x}<={y} As Long ~~ Precedence: 5", ucAddr(uc_Op_LessOrEqual_Extended)
   ucDefine "Op:: {x}<>{y} As Long ~~ Precedence: 5", ucAddr(uc_Op_NotEqual_Extended)
   ucDefine "Op:: {x}=={y} As Long ~~ Precedence: 5", ucAddr(uc_Op_Equal_Extended)

   ucDefine "Op:: {x As String}>{y As String}  As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterThan_Str)
   ucDefine "Op:: {x As String}<{y As String}  As Long ~~ Precedence: 5", ucAddr(uc_Op_LessThan_Str)
   ucDefine "Op:: {x As String}>={y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterOrEqual_Str)
   ucDefine "Op:: {x As String}<={y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_LessOrEqual_Str)
   ucDefine "Op:: {x As String}<>{y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_NotEqual_Str)
   ucDefine "Op:: {x As String}=={y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_Equal_Str)

   ucDefine "Op:: {x As Long} And     {y As Long} As Long ~~ Precedence: 4", ucAddr(uc_Op_And_Int32)
   ucDefine "Op:: {x}         AndAlso {ByExpr y}          ~~ Precedence: 4", ucAddr(uc_Op_AndAlso)
   ucDefine "Op:: {x As Long} Or      {y As Long} As Long ~~ Precedence: 3", ucAddr(uc_Op_Or_Int32)
   ucDefine "Op:: {x}         OrElse  {ByExpr y}          ~~ Precedence: 3", ucAddr(uc_Op_OrElse)

   ucDefine "Op:: {x As Double}+{y As Double} As Double ~~ Precedence: 10", ucAddr(uc_Op_Add_Double)
   ucDefine "Op:: {x As Double}-{y As Double} As Double ~~ Precedence: 10", ucAddr(uc_Op_Subtract_Double)
   ucDefine "Op:: {x As Double}*{y As Double} As Double ~~ Precedence: 20", ucAddr(uc_Op_Multiply_Double)
   ucDefine "Op:: {x As Double}/{y As Double} As Double ~~ Precedence: 20", ucAddr(uc_Op_Divide_Double)
   ucDefine "Op:: {x As Double} Mod {y As Double} As Double ~~ Precedence: 20", ucAddr(uc_Op_Mod_Double)
   ucDefine "Op:: {x As Double}^{y As Double} As Double ~~ Precedence: 30", ucAddr(uc_Op_PowerOf_DblToDbl)

   ucDefine "Op:: {x As Long}!  ~~ Precedence: 40", ucAddr(uc_Op_Factorial)
   ucDefine "Op:: {x As Long}\{y As Long} As Long ~~ Precedence: 20", ucAddr(uc_Op_Divide_Int32)

   ucDefine "Func:: Sin(x As Double) As Double", ucAddr(uc_Func_Sin_Dbl)
   ucDefine "Func:: Cos(x As Double) As Double", ucAddr(uc_Func_Cos_Dbl)
   ucDefine "Func:: Tan(x As Double) As Double", ucAddr(uc_Func_Tan_Dbl)
   ucDefine "Func:: Atan(x As Double) As Double", ucAddr(uc_Func_Atan_Dbl)
   ucDefine "Func:: Abs(x As Double) As Double", ucAddr(uc_Func_Abs_Dbl)
   ucDefine "Func:: Exp(x As Double) As Double", ucAddr(uc_Func_Exp_Dbl)
   ucDefine "Func:: Log(x As Double) As Double", ucAddr(uc_Func_Log_Dbl)
   ucDefine "Func:: Ceil(x As Double) As Long", ucAddr(uc_Func_Ceil_Dbl)
   ucDefine "Func:: Sqr(x As Double) As Double", ucAddr(uc_Func_SquareRoot_Dbl)
   ucDefine "Func:: Int(x)", ucAddr(uc_Func_Int)
   ucDefine "Func:: Frac(x)", ucAddr(uc_Func_Frac)
   ucDefine "Func:: Sgn(x)", ucAddr(uc_Func_Sgn)
   ucDefine "Func:: Rand(x = 1)", ucAddr(uc_Func_Rand)
   ucDefine "Func:: Rand(x As Long, y As Long)", ucAddr(uc_Func_Rand)

   ucDefine "Syntax: Max({x}, {y}) ::= IIf({x} > {y}, {x}, {y})"
   ucDefine "Syntax: Max({x}, {y}, {etc}) ::= Max({x}, Max({y}, {etc}))"
   ucDefine "Syntax: Min({x}, {y}) ::= IIf({x} < {y}, {x}, {y})"
   ucDefine "Syntax: Min({x}, {y}, {etc}) ::= Min({x}, Min({y}, {etc}))"

   ucDefine "Func:: BaseConvert(Number As String, Base As Long)", ucAddr(uc_Func_BaseConvert)

   ucDefine "Func:: iif(cond As Long, ByExpr TruePart As String, ByExpr FalsePart As String = '') As String", ucAddr(uc_Func_IIf_Str)
   ucDefine "Func:: iif(cond As Long, ByExpr TruePart, ByExpr FalsePart = 0)", ucAddr(uc_Func_IIf)
   ucDefine "Func: Inf() = 1/0"
   ucDefine "Func: NaN() = 0/0"

   ucDefine "Func:: Error(Message As String)", ucAddr(uc_Raise_Error)
   ucDefine "Func:: ucAddr(index)", ucAddr(uc_Func_ucAddr)
   ucDefine "Func:: ValueAtAddr(DataType As Dword, Address As Dword, Index As Long = 0) ~~ ValueAtAddr", ucAddr(uc_Func_ValueAtAddr)
   ucDefine "Func:: BatchEval(ByHandle Var As Double, ByHandle VarArray As Double, ByHandle ResultArray As Double, " _
           +"Count As Long, ByExpr Expr As Double) As Void", ucAddr(uc_Func_Batch_Eval)

   ucDefine "Var: NullStr As String At #", ucAddr(uc_NullString)
   ucDefine "Func:: uCalc(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0," _
           + "MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = 0) As Long", ucAddr(uc_Func_uCalc)

   ucDefine "Func:: uCalcStr(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0," _
           + "MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = 0) As String", ucAddr(uc_Func_uCalcStr)

   ucDefine "Syntax: Precedence({Item}) ::= uCalc("+Str$(uc_GetItemData)+", {Item}, 0, "+Str$(uc_Precedence)+", 0, ~t)"

   ucDefine "Func:: uc_Loop(ByExpr DoCondition, ByExpr Expression As AnyType, ByExpr LoopCondition) As Void", ucAddr(uc_Func_Loop)
   ucDefine "Func:: uc_For(ByHandle Counter As AnyType, Start, Finish, Step, ByExpr Expr As AnyType) As Void", ucAddr(uc_Func_For)

   ucDefine "Func:: Asc(Character As String, Position As Long = 1) As Long", ucAddr(uc_Func_Asc)
   ucDefine "Func:: Chr(Code As Long) As String", ucAddr(uc_Func_Chr)

   ucDefine "Var: _Number As String = '([0-9]*\.)?[0-9]+(e[-+]?[0-9]+)?'"
   ucDefine "Var: _HexNumber As String = '([0-9a-z]*\.)?[0-9a-z]+(e[-+]?[0-9]+)?'"
   ucDefine "Var: _Alpha As String = '[a-z_][0-9a-z_]*'"
   ucDefine "Syntax: {Num:_Number}{Alpha:_Alpha} ::= {Num}*{Alpha}"
   ucDefine "Syntax: {'#b'}{Number:_Number} ::= ~Eval(BaseConvert('{Number}', 2))"
   ucDefine "Syntax: {'#o'}{Number:_Number} ::= ~Eval(BaseConvert('{Number}', 8))"
   ucDefine "Syntax: {'#h'}{Number:_HexNumber} ::= ~Eval(BaseConvert('{Number}', 16))"

   ucDefine "Const: uc_Define = " + Str$(uc_Define)
   ucDefine "Syntax: ucDefine({Def}) ::= uCalc(uc_Define, {Def}, 0, 0, 0, ~t)"

   ucDefine "Syntax: Local([{' +'}]{Variable:'[^=, ]+'}[{etc}], {Expr}) ::= ~Eval_P(ucDefine('Var: {Variable} {etc}')) {Expr} ~Eval_P(ucRename('{Variable}', ''))"
   ucDefine "Syntax: Local({Variable1}, {OtherVariables}, {Expr}) ::= Local({Variable1}, Local({OtherVariables}, {Expr}))"

   ucDefine "Const: uc_DefineSyntax = " + Str$(uc_DefineSyntax)
   ucDefine "Func:: SetSyntaxParams(Params As String, Expr As String, t As Dword = 0) As String", ucAddr(uc_Func_SetSyntaxParams)
   ucDefineSyntax "Macro: {name} [{args:'\([^\)]*\)'}] = {replacement} ::= Syntax: ~Eval(SetSyntaxParams('{args}', '{name}{args} ::= {replacement}'))"

   ucDefine "Const: uc_GetItemData = " + Str$(uc_GetItemData)
   ucDefine "Const: uc_SetItemData = " + Str$(uc_SetItemData)
   ucDefine "Const: uc_SymbolName = " + Str$(uc_SymbolName)
   ucDefine "Const: uc_Handle = " + Str$(uc_Handle)
   ucDefine "Syntax: ucHandle({Item}) ::= uCalc(uc_GetItemData, {Item}, 0, uc_Handle, 0, ~t)"
   ucDefine "Syntax: ucRename({OldName}, {NewName})" _
           +"::= uCalc(uc_SetItemData, {NewName}, ucHandle({OldName}), uc_SymbolName, 0, ~t)"

   ' Arrays
   ucDefine "Const: uc_Address = " + Str$(uc_Address)
   ucDefine "Const: uc_DataType = " + Str$(uc_DataType)
   ucDefineSyntax "Address({Item}) ::= ~Eval(uCalc(uc_GetItemData, '{Item}', 0, uc_Address, 0, ~t))"
   ucDefineSyntax "DataType({Item})::= ~Eval(uCalc(uc_GetItemData, '{Item}', 0, uc_DataType, 0, ~t))"
   ucDefine "PassOnce ~~ Syntax: NextDef {etc:'.+'} ::= NextDef {etc}"

   ucDefineSyntax "Var: {'[ ]*'}{ArrayName:_Alpha} ({MaxIndex}) [{etc}]" _
   + "::= Count: {MaxIndex} ~~ Var: {ArrayName} {etc} ~~ NextDef ~~" _
   + "Syntax: {ArrayName} ({Index}) ::= ValueAtAddr(DataType({ArrayName}), Address({ArrayName}), {Index})"

   ' Assign Value to Variable    
   ucDefine "Func:: SetVar(ByHandle Var As AnyType, ByHandle Value As String) As Void", ucAddr(uc_SetVariableValueAnyType)
   ucDefine "Func:: SetVar(ByHandle Var As AnyType, ByHandle Value As Double) As Void", ucAddr(uc_SetVariableValueAnyType) 
   ucDefine "Func:: SetVar(ByHandle Var As Double, ByHandle Value As Double) As Void", ucAddr(uc_SetVariableValueDouble)

   ucDefine "DefaultType: Double"
End Function
